package jdaemon;

import java.io.IOException;
import java.util.Timer;
import java.util.TimerTask;

/**
 * 풓ʃNX
 */
public abstract class DaemonProcess extends TimerTask
{
	// O
	private String name;

	// ^C}[
	private Timer timer;

	// Iw󂯎pSocketT[o
	private DaemonObserver observer;

	// |[gԍ
	private int port;

	/**
	 * 풓Jn
	 * @param name 풓
	 * @param delay Jnx
	 * @param period sԊu
	 */
	public void start(String name, long delay, long period, int port) throws IOException
	{
		// ϐ
		this.port = port;

		// 풓Iw󂯎pSocketT[o\z
		this.observer = new DaemonObserver(this, port);
		observer.start();

		// 
		this.name = name;
		this.timer = new Timer();
		timer.scheduleAtFixedRate(this, delay, period);

		// s
		init();
	}

	/**
	 * 
	 */
	public void run()
	{
		try
		{
			exec();
		}
		catch(Throwable t)
		{
			// G[s\ǂfB
			if(isShutDown(t))
			{
				stop(t);
			}
		}
	}

	/**
	 * 풓I
	 */
	void stop() throws IOException
	{
		// ns
		destroy();

		// ĎpSocketT[o~
		observer.stopServer();

		// 풓~
		timer.cancel();
	}

	/**
	 * 풓IiG[j
	 */
	void stop(Throwable t)
	{
		try
		{
			// 풓IĎT[oɐڑA풓~ʒmB
			DaemonStopClient.stop(port);

			t.printStackTrace();
		}
		catch(IOException e)
		{
			// IG[͖
		}
	}

	/**
	 * O擾
	 * @return O
	 */
	public String getName()
	{
		return name;
	}

	/**
	 * eiTuNXŃI[oChj
	 */
	protected void init()
	{
	}

	/**
	 * eiTuNXŎj
	 */
	protected abstract void exec();

	/**
	 * IeiTuNXŃI[oChj
	 */
	protected void destroy()
	{
	}

	/**
	 * G[s۔
	 */
	protected boolean isShutDown(Throwable t)
	{
		return true;
	}
}
